---
title: "Creation of classifiers (multiclasspairs, random forest, pamr, random forest src) and predictions with Glioblastoma data (genes expressions)"
output: html_document
date: "2023-08-17"
author : Marion Estoup
---



# Step 1 : Multiclasspairs with all data
  
The workflow in Multiclasspairs always starts with ReadData function. Then, 
there are two schemes to train our pair-based classifier:
  
First option is a one-vs-rest scheme that assemble one-vs-rest binary classifiers built by ‘switchBox’ package which uses Top-score pairs (TSP) algorithm.

The second option is a scheme based on a novel implementation of the random forest (RF) algorithm

For more complex predictions, RF performs better. For less complex predictions, 
it's recommended to use one-vs-rest due to its straightforward application and interpretation.

Both workflows begin by filtering the features, then combining the filtered features to make the list of all the possible rules (i.e. rule1: feature1 < feature2, rule2: feature1 < feature3, etc…). Then the list of rules will be filtered and the most important and informative rules will be kept. The informative rules will be assembled in an one-vs-rest model or in an RF model. 


## Load/install libraries
```{r message=FALSE, warning=FALSE, results='hide'}
library(multiclassPairs) # classification
library(caret) # For confusion matrix
library(ComplexHeatmap) # For heatmap
library(pamr) # classification
library(randomForestSRC) # classification
library(interp) # Plot mtry according to nodesize 
library(htmlwidgets) # save plot
library(scales) # palette colors
library(dplyr) # data management/manipulation
library(stringr) # data management/manipulation
library(stringi) # data management/manipulation
library(tibble) # data management/manipulation
library(Biobase) # Expressionset data/object
library(writexl) # Save files
```


## Load and Explore data

We have data about genes expressions with 483 samples and 1070 features (genes) concerning  glioblastoma.
```{r message=FALSE, warning=FALSE}

################################# DATA MANAGEMENT/MANIPULATION 

############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO DATA AND PATH

# Set seed for reproductibility
set.seed(1234)

# Set path
setwd("C:/Users/mario/Desktop/Data/")


# Load data
load("exp_TCGAGBM_agilent_clsf1.Rdata")


# Multiclasspairs needs ExpressionSet Object so a matrix (gene expression/influence) with samples in columns and gene names in rownames and it needs a dataframe (phenotype data) with samples in rownames and one column classes/outcomes
# That's what we do in this step so depending on your data you just have to create a dataframe called classes_samples with samples in rownames and one column called classes (factor format) and then one matrix called inftum_matrix with gene names in rownames and samples in columns. Thanks to both object you have to create an ExpressionSet Object called expressionset_data. If you have those names you can run the code and change some parameters if you want to in the different functions.

# Random Forest can also use an ExpressionSet Object because we perform it with multiclasspairs library directly. If it's another package it's possible that data should be in another format


# PAMR needs a matrix (gene expression/influence) with samples in columns and gene names in rownames and it needs a dataframe with samples in rownames and one column classes/outcomes  (it's done later in the code based on expressionset_data)

# Random Forest SRC needs a matrix (gene expression/influence) with gene names in columns and samples in rownames. In this matrix, we also need to have a column classes/outcomes in addition of the gene names. It also needs a dataframe with samples in rownames and one column classes/outcomes
# (it's done later in the code based on expressionset_data)


# Explore data
#str(exp_TCGAGBM_agilent_clsf1)
#class(exp_TCGAGBM_agilent_clsf1)
#unique(as.vector(exp_TCGAGBM_agilent_clsf1[,"classf_1"]))

# 7 classes from 1 to 7
# Gene names in columns and also classes in column
# Samples in rownames 


# Create dataframe with classes and samples 
classes_samples <- data.frame(exp_TCGAGBM_agilent_clsf1[,"classf_1"])

# Rename column
names(classes_samples)[names(classes_samples) == "exp_TCGAGBM_agilent_clsf1....classf_1.."] <- "classes"

# Check data structure
#str(classes_samples)

# If classes/outcomes aren't factor you have to convert them with the following
classes_samples$classes <- as.factor(classes_samples$classes)

# Create matrix with gene names in rownames and samples in columns

# Create matrix and remove classes/outcomes column
inftum_matrix <- exp_TCGAGBM_agilent_clsf1[,-1]
# Transpose matrix
inftum_matrix <- t(inftum_matrix)
# Replace hyphens - by _ in rownames (gene names) in order to avoid issues with random forest
rownames(inftum_matrix) <- gsub("-", "_", rownames(inftum_matrix))

# Check if samples are in the same order in dataframe and matrix
#identical(rownames(classes_samples),colnames(inftum_matrix)) # TRUE

# Check if nan values in dataframe and matrix
#sum(is.na(classes_samples)) # 0
#sum(is.na(inftum_matrix)) # 19 

# If there are nan values you can do the following to remove them otherwise the next analysis won't work (remove or replace by values)
inftum_matrix <-inftum_matrix[complete.cases(inftum_matrix * 0), , drop=FALSE]



# Create Expression set object thanks to matrix (for expression data) and dataframe (for phenotype data)
expressionset_data <- ExpressionSet(assayData = inftum_matrix,
                                    phenoData = AnnotatedDataFrame(classes_samples))
```




```{r message=FALSE, warning=FALSE}
# Have a look at gene expression values in expression set
knitr::kable(head(exprs(expressionset_data)))
# Samples Sjo.BLCA_Cx_1, Sjo.BLCA_Cx_2, ... are in columns
# Genes  TP63, GATA3, ... are in rownames
```

```{r message=FALSE, warning=FALSE}
# Have a look at phenotype data in expression set
knitr::kable(head(pData(expressionset_data)))
```


## Prepare data
```{r message=FALSE, warning=FALSE, results='hide'}
## Prepare data
# To perform classification, we need to have test and train data
# Thus, we split the data
# 60% as training data and 40% as testing data
n <- ncol(expressionset_data) # columns (samples) 
training_samples <- sample(1:n,size = n*0.6)
train <- expressionset_data[1:1070,training_samples] # We take only 1070 genes (the total)
test <- expressionset_data[1:1070,-training_samples] 

# To be sure there are no shared samples between the training and testing data
sum(sampleNames(test) %in% sampleNames(train)) == 0
# TRUE so no shared samples between training and testing data
```


```{r echo=TRUE, message=FALSE, warning=FALSE}
# Create the data object (we don't need to manipulate data with multiclasspairs, we can directly use an ExpressionSet object)
# When we use Expressionset we can use the name of the phenotypes variable 
# ReadData will automatically extract the phenotype variable and use it as class labels
# The same can be used with the Platform/study labels
# In this example we are not using any platform labels, so leave it NULL
object <- ReadData(Data = train, 
                   Labels = "classes", 
                   Platform = NULL, 
                   verbose = FALSE)
object
```


## One vs rest scheme

One-vs-rest scheme is composed from binary individual classifiers for each class (i.e. each class versus others). Each binary classifier votes (i.e. give a score) for the predicted sample, and the sample’s class is predicted based on the highest score.

For building a pair-based classifier with a one-vs-rest scheme, we start by selecting top differentially expressed genes using the filter_genes_TSP function. This reduces the number of gene combinations (rules) in the next steps. This function can perform the filtering in different ways and return the top differential expressed genes for each class.

filter_genes_TSP function provides two options for gene filtering. Both options begins by ranking the data (i.e. in-sample ranking). The first option performs one-vs-rest comparison using Wilcoxon test and then selects a number of the top genes. Wilcoxon test is done separately for each class. The second option performs one-vs-one comparison using Dunn’s test, and then selects a number of the top genes. Dunn’s test is performed for all classes together.


```{r echo=T, results='hide', message=F, warning=F}
# Apply filter_genes_TSP function on our object
filtered_genes <- filter_genes_TSP(data_object = object, # data
                                   filter = "one_vs_one", # filter type
                                   platform_wise = FALSE, # platform
                                   featureNo = 8, # Number of top genes per class that we want
                                   UpDown = TRUE, 
                                   verbose = TRUE)
```



```{r echo=TRUE}
# Show result of filtered_genes
filtered_genes
```

If we ask for a specific number of genes and that we don't have it in the results of filter_genes_TSP, it's because the function did not find enough genes matching the top genes criteria (i.e. high/low in the class and the opposite in the other classes).




## Model Training

After filtering the genes, we can train our model using train_one_vs_rest_TSP function. This function combines the filtered genes as binary rules (GeneA < GeneB, GeneA < GeneC, etc.) then rules are sorted based on their score, and the optimal number of rules among the input range (i.e. k_range argument) is selected. The optimal number of rules is determined internally through the SWAP.Train.KTSP function from switchBox which uses Variance Optimization (VO) method as in (Afsari et al. 2014).

Rules scoring is performed by the traditional scoring method (Geman et al. 2004). Briefly, the score for a given rule equals the percentage of samples those are TRUE for the rule in the class minus the percentage of the samples those are TRUE for the rule in another group(s). train_one_vs_rest_TSP function gives two scoring options: one-vs-rest and one-vs-one. In one-vs-rest scoring option, all the rest classes are grouped in one ‘rest’ group. In one-vs-one scoring option, the score is calculated as the mean of one-vs-one rule scores. The reason for using one-vs-one option is to give more weight to small classes.

Scores can also be calculated in a platform-wise manner where the score is calculated in each platform/study separately, then the mean of these scores will be the final score for the rule.

The k_range argument defining the candidate number of top rules from which the algorithm chooses to build the binary classifier for each class. Note that during prediction process (i.e. class voting) binary classifiers with low number of rules tie more than binary classifiers with higher number of rules. Because of that, it is recommended to use sufficient number of rules to avoid the score ties. Sufficient number of rules depends on how many classes we have and on how much these classes are distinct from each other.

Rules have two sides (i.e. GeneA < GeneB), usually rules are composed from two differently expressed genes (i.e. filtered genes). However, invariant genes (called pivot genes) can be involved in the rules through include_pivot argument. If include_pivot argument is TRUE, then the filtered genes will be combined with all genes in the data allowing rules in form of ‘filtered genes < pivot gene’ and ‘pivot gene < filtered genes’. This may increase the training time due to increase the number of the possible rules.

```{r echo=TRUE}

# Let's train our model
classifier <- train_one_vs_rest_TSP(data_object = object, # data
                                    filtered_genes = filtered_genes, # filtered genes
                                    k_range = 5:50, # range
                                    include_pivot = FALSE,
                                    one_vs_one_scores = TRUE,
                                    platform_wise_scores = FALSE,
                                    #seed = 1234,
                                  verbose = FALSE)

# Show classifier
classifier
```



So, in our trained model we have 5 binary classifiers for all classes with 5 rules for each.


Now, let’s apply our trained model on the training and testing data to assess its performance. We can do that through predict_one_vs_rest_TSP function.

Note that, in some cases the testing data miss some features or genes, predict_one_vs_rest_TSP can deal with this through ignoring the rules with missed genes. However, if a lot of rules are ignored the prediction may be affected to large extend.

predict_one_vs_rest_TSP returns a data.frame with class scores, score ties, and final prediction based on the max score.

```{r echo=T, message=FALSE, warning=FALSE, results='hide'}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 

# Apply classifier on the training data
# To have the classes in output in specific order, we can use classes argument
results_train <- predict_one_vs_rest_TSP(classifier = classifier,
                                         Data = object,
                                         tolerate_missed_genes = TRUE,
                                         weighted_votes = TRUE,
                                         classes = c("1","2","3",
                                                     "4","5", "6",
                                                     "7"),
                                         verbose = TRUE)

# Apply classifier on the testing data
results_test <- predict_one_vs_rest_TSP(classifier = classifier,
                                        Data = test,
                                        tolerate_missed_genes = TRUE,
                                        weighted_votes = TRUE,
                                        classes = c("1","2","3",
                                                    "4","5", "6",
                                                    "7"),
                                        verbose = TRUE)
```


```{r echo=TRUE}
# Get a look over the scores in the testing data
knitr::kable(head(results_test))

```


## Metrics for training data
```{r echo=TRUE}
# Let’s check the accuracy in the training and testing data.
# Confusion Matrix and Statistics on training data
confusionMatrix(data = factor(results_train$max_score, 
                              levels = unique(object$data$Labels)),
                reference = factor(object$data$Labels,
                                   levels = unique(object$data$Labels)),
                mode="everything")

```


## Metrics for testing data
```{r echo=TRUE}
# Confusion Matrix and Statistics on testing data
confusion_matrix_multiclasspairs <- confusionMatrix(data = factor(results_test$max_score, 
                                                                  levels = unique(object$data$Labels)),
                                                    reference = factor(pData(test)[,"classes"], 
                                                                       levels = unique(object$data$Labels)),
                                                    mode="everything")

# Print confusion matrix obtained with Multiclasspairs
confusion_matrix_multiclasspairs
```


## Visualization

Finally it is recommended to visualize the rules in the training and testing data. This will give you an idea to which level the rules and predictions are good.
```{r echo=TRUE, message=FALSE, warning=FALSE, error = TRUE}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 

# We can plot binary heatmap plots through plot_binary_TSP function as follows:

# Plot for the rules and scores in the training data
plot_binary_TSP(Data = object, # we are using the data object here
                classifier = classifier, 
                prediction = results_train, 
                classes = c("1","2","3","4","5","6","7"),
                #margin = c(0,5,0,10),
                title = "Training data")
```


```{r echo=TRUE, message=FALSE, warning=FALSE, error = TRUE}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 

# Plot for the rules and scores in the testing data
plot_binary_TSP(Data = test, # Test data
                ref = "classes", # ref = label/classes/outcomes 
                classifier = classifier, 
                prediction = results_test, 
                classes = c("1","2","3","4","5","6","7"),
                title = "Testing data"#, 
                #margin = c(0,5,0,10)
)
```


## Heatmap with top genes obtained with multiclasspairs

```{r message=FALSE, warning=FALSE, results='hide'}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 

# Store top genes found with multiclasspairs for each class 
top5_multiclasspairs_1 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["1"]]
top5_multiclasspairs_2 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["2"]]
top5_multiclasspairs_3 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["3"]]
top5_multiclasspairs_4 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["4"]]
top5_multiclasspairs_5 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["5"]]
top5_multiclasspairs_6 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["6"]]
top5_multiclasspairs_7 <- filtered_genes[["OnevsrestScheme"]][["filtered_genes"]][["7"]]



# Store top genes found with multiclasspairs for each class in one variable only
top50_multiclasspairs <- c(top5_multiclasspairs_1, top5_multiclasspairs_2,
                           top5_multiclasspairs_3, top5_multiclasspairs_4,
                           top5_multiclasspairs_5, top5_multiclasspairs_6,
                           top5_multiclasspairs_7)

# Check if duplicated genes
length(top50_multiclasspairs) # 
length(unique(top50_multiclasspairs)) # 

# If there are duplicated genes we can do the following to remove them
top50_multiclasspairs <- unique(top50_multiclasspairs)
```



```{r echo=TRUE}
# Retrieve expression genes values and samples corresponding to our top 50 genes 
top50_multiclasspairs <- exprs(expressionset_data)[top50_multiclasspairs,]
# We have a matrix with k samples in columns and k top differentially expressed genes in rownames
```


```{r echo=TRUE}
# Scale data before heatmap
top50_multiclasspairs <- scale(top50_multiclasspairs, center = TRUE, scale = TRUE)
```


## Heatmap with top k genes obtained with Multiclasspairs
```{r echo=TRUE, message=FALSE, warning=FALSE}

############### STEP THAT NEEDS TO BE ADAPTED WITH CLASSES NAMES 


### Heatmap Top genes Multiclasspairs

# Create pheno that contains phenotypes data from our expressionset object
pheno <- pData(expressionset_data)

# Create object ann to store classes/outcomes
ann <- data.frame(pheno[,"classes",drop=FALSE])



# Assign a color for each different class thanks to a palette of colors hue_pal
palette_colors <- hue_pal()(length(unique(ann$classes)))%>%
  rlang::set_names(unique(ann$classes))

# 1         3         4         7         6         5         2 
# "#F8766D" "#C49A00" "#53B400" "#00C094" "#00B6EB" "#A58AFF" "#FB61D7" 


# Now that we have the specific color for each class we can create a column
# colors in ann df to have the corresponding color in front of each class/row
ann <- 
  ann%>%
  mutate(colours = 
           case_when(.$classes %in% "1" ~ "#F8766D",
                     .$classes %in% "2" ~ "#FB61D7",
                     .$classes %in% "3" ~ "#C49A00",
                     .$classes %in% "4" ~ "#53B400",
                     .$classes %in% "5" ~ "#A58AFF",
                     .$classes %in% "6" ~ "#00B6EB",
                     .$classes %in% "7" ~ "#00C094")
  )


# Order class/outcome in ann df (all samples that belong to class 1, then all samples that belong to class 2, then all samples that belong to class 3, etc)
ann <- arrange(ann,classes)



# Now that we have the column with all colours corresponding to each class we can retrieve
# this column and store it in a vector
colours_vector <- ann$colours
#colours_vector

# And we can assign the classes in front of each color in this vector
names(colours_vector) <- ann$classes
#colours_vector

# Now we can remove the column colours in ann df because we don't need it
# We have the info in colours_vector
ann$colours = NULL


# Order columns in matrix to have the same order as the new rownames order in ann df
top50_multiclasspairs <- top50_multiclasspairs[ , rownames(ann)]


# Create colAnn that contains classes/outcomes and corresponding colours to give to the  heatmap function after
colAnn <- HeatmapAnnotation(df = ann, # data
                            which = 'col',
                            col = list(classes=colours_vector), # colour list
                            show_annotation_name = FALSE, # remove annotation name
                            annotation_legend_param = list(title="Classes")
)


# Open png instance if you want to save heatmap
png(file="heatmap_multiclasspairs.png")

# Create heatmap
heatmap_multiclasspairs <- Heatmap(column_title="Top k genes with multiclasspairs
                                   Samples",
                                   top50_multiclasspairs, # data
                                   name = "Genes exp", #title of legend
                                   row_title = "Genes", # title of rows
                                   column_names_gp = gpar(fontsize = 5), # text size
                                   row_names_gp = gpar(fontsize = 5), # text size
                                   show_column_dend = FALSE, # don"t show dendrogram for cols
                                   cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                                   column_dend_reorder = FALSE, # same as cluster_columns
                                   top_annotation = colAnn, # give the colors for classes
                                   show_column_names = FALSE) # don't show column names (not readable because lot of samples/columns)



# Display/draw matrix
draw(heatmap_multiclasspairs)
# Stop graph device
dev.off()

```


```{r echo=TRUE}
# Draw heatmap obtained with multiclasspairs
draw(heatmap_multiclasspairs)
```


## Conclusion Multiclasspairs 

We had inftum as a matrix with genes in rownames and samples in columns. This data contained the gene expressions of the most differentially expressed genes because Limma package was used before, which gave this inftum data. To use multiclasspairs we need an ExpressionSet object. Thus, we created one with expression data (samples in columns, genes in rownames) and phenotype data (samples in rownames and one column containing the classes/outcomes). Then we used this ExpressionSet to create test and train datasets (60% for training and 40% for testing data). We also had to change hyphens in gene names (- by _) to make the random forest algorithm work.



Samples look like the following : TCGA-02-0001, TCGA-02-0003, TCGA-02-0004 etc.
There are 7 different classes stored in classes column (dataframe classes_samples) : 1, 2, 3, 4, 5, 6, 7. 



The object for training contains 289 samples and 491 features (all genes from inftum data). While the object for testing contains 191 samples and 491 features (all genes from inftum data).


The first heatmaps indicate the rules for the training and the testing.
The last heatmap shows the top k genes expression values according to samples (obtained with multiclasspairs library).


For more information :

https://github.com/NourMarzouka/multiclassPairs

https://cran.r-project.org/web/packages/multiclassPairs/multiclassPairs.pdf

https://www.datanovia.com/en/lessons/heatmap-in-r-static-and-interactive-visualization/

https://search.r-project.org/CRAN/refmans/multiclassPairs/html/00Index.html






# Step 2 : Random Forest with all data

In Random Forest (RF) scheme, all steps of gene filtering/sorting, rule filtering/sorting, and final model training are performed using the RF algorithm.

The ranger package is used to run the RF algorithm, and arguments can be passed to ranger function if any changes are needed


## Sort genes

To reduce the number of the genes, sort_genes_RF function sorts the genes based on their importance and take the top important genes. Gene importance is determined based on the ability of the gene to split the classes better than other genes.

To get the important (i.e. informative) genes sort_genes_RF function performs two types of sorting genes, first type is “altogether” which runs the RF algorithm to sort the genes based on their importance in all classes from each other, this generates one list of sorted genes for the whole data. The second type is “one_vs_rest” which runs the RF algorithm to sort the genes based on their importance in splitting one class from the rest, this generates sorted list of genes for each class. It is recommended (default) to run both, particularly in case of class imbalance in the training data.

By default, all genes are sorted and returned, and the user can specify how many top genes will be used in the downstream functions. However, the user can specify how many genes should be returned using featureNo_altogether and featureNo_one_vs_rest arguments, and if one of these arguments is 0, then that sorting type will be skipped.

Like One-vs-rest scheme, platform-wise option is available for the Random Forest scheme where the genes and rules can be sorted in each platform/study individually then the top genes in all of them will be taken. This gives more weight to small platforms/studies and try to get genes that function equally well in all platforms/studies.

It is recommended to run all function in the RF scheme with seeds to get reproducible results each time.
```{r echo=T, results='hide', message=F, warning=F}
# (500 trees here just for fast example)
# Thanks to multiclasspairs, we can use random forest algorithm
# Thus, we can use an ExpressionSet object directly without changing it
genes_RF <- sort_genes_RF(data_object = object,
                          featureNo_altogether=50, #it is better not to specify a number here
                          # featureNo_one_vs_rest, it is better not to specify a number here
                          rank_data = TRUE,
                          platform_wise = FALSE,
                          num.trees = 500, # more features, more tress are recommended
                          #seed=1234, # for reproducibility
                          verbose = TRUE)
genes_RF # sorted genes object
```



## Sort rules

After we sorted the genes, we need to take the top genes and combine them as binary rules and then sort these rules. This can be performed using sort_rules_RF function. Here, we need to determine how many top genes to use.

Like sorting genes options, rules sorting can be performed in “altogether”, “one_vs_rest”, and “platform_wise” options. By default, both “altogether” and “one_vs_rest” rule sorting are performed.

Parameter optimization:
  
  The summary_genes_RF function is an optional function in the workflow. summary_genes_RF function gives an idea of how many genes you need to use to generate a specific number of rules.

The summary_genes_RF function checks different values of genes_altogether and genes_one_vs_rest arguments in sort_rules_RF function. summary_genes_RF works as follows: take the first element in genes_altogether and genes_one_vs_rest arguments, then bring this number of top genes from altogether slot and one_vs_rest slots (this number of genes will be taken from each class), respectively, from the sorted_genes_RF object. Then pool the extracted genes and take the unique genes. Then calculate the number of the possible combinations. Store the number of unique genes and rules in first row in the output data.frame then pick the second element from the genes_altogether and genes_one_vs_rest and repeat the steps again. NOTE: gene replication in rules is not considered, because the rules are not sorted yet in the sorted_genes_RF object.

Another way, but computationally more extensive, is to use large and sufficient number of genes, this will produce large number of rules, then we can use run_boruta=TRUE argument in the training function (i.e. train_RF function), this will remove the uninformative rules before training the final model.



```{r echo=T, results='hide', message=F, warning=F}
# Let's run sort_rules_RF to create the rules and sort them
rules_RF <- sort_rules_RF(data_object = object, 
                          sorted_genes_RF = genes_RF,
                          genes_altogether = 50,
                          genes_one_vs_rest = 50, 
                          num.trees = 500,# more rules, more trees are recommended 
                          #seed=1234,
                          verbose = TRUE)
rules_RF # sorted rules object
```


## Model training

Now, we have the rules sorted based on their importance. Now we can train our final RF model. We can go with the default settings in the train_RF function directly :

It is recommend to run Boruta option (run_boruta=TRUE) to remove the uniformative rules, thus use less genes and rules in the model. Note: When run_boruta=TRUE the training process may take long time if the number of rules is large.

It is recommended to train the final model with probability=TRUE, this will allow the model to give additional scores for each class instead of class prediction without scores.


```{r echo=T, results='hide', message=F, warning=F}

# Train our classifier with train_RF function
RF_classifier <- train_RF(data_object = object,
                          sorted_rules_RF = rules_RF,
                          gene_repetition = 1,
                          rules_altogether = 10,
                          rules_one_vs_rest = 10,
                          run_boruta = TRUE, 
                          plot_boruta = FALSE,
                          probability = TRUE,
                          num.trees = 300,
                          boruta_args = list(),
                          verbose = TRUE)

# Show Random Forest classifier
RF_classifier
```




## Training accuracy

For the training accuracy, we do not apply the RF model on the training data, because this gives 100% accuracy (almost always) which is not reliable. Instead we use the out-of-bag predictions, which can be obtained as follows:
```{r echo=TRUE}

# Create matrix that contains predictions for each class
training_pred <- RF_classifier$RF_scheme$RF_classifier$predictions # It's a matrix

# If matrix is a factor we create x as character
if (is.factor(training_pred)) {
  x <- as.character(training_pred)
}

# If matrix is a matrix we create x with max col of matrix
if (is.matrix(training_pred)) {
  x <- colnames(training_pred)[max.col(training_pred)]
}

# Create confusion matrix
confusionMatrix(data =factor(x),
                       reference = factor(object$data$Labels),
                       mode = "everything")
```




## Prediction

We predict the class in the test samples by running the predict_RF function. Note that you can use impute = TRUE to handle missed genes in the test data. This is done by filling the missed rule values based on the closest samples in the training data. RF models are good enough to handle large percent of missed rules (up to 50% in some cases) without large effect on the accuracy of the prediction.
```{r echo=TRUE, message=FALSE, warning=FALSE}
# Apply random forest classifier on test data
results <- predict_RF(classifier = RF_classifier, 
                      Data = test,
                      impute = TRUE) # can handle missed genes by imputation

# Create matrix to retrieve the predictions  
test_pred <- results$predictions # It's a matrix

# If matrix is a factor we create x as character
if (is.factor(test_pred)) {
  x <- as.character(test_pred)
}

# If matrix is a matrix we create x with max col of matrix
if (is.matrix(test_pred)) {
  x <- colnames(test_pred)[max.col(test_pred)]
}

# Create confusion matrix
confusion_matrix_rf <- confusionMatrix(data = factor(x),
                       reference = factor(pData(test)[,"classes"]),
                       mode = "everything")

# SHow confusion matrix for test data using random forest classifier
confusion_matrix_rf
```



## Visualisation
```{r echo=TRUE, error = TRUE}
# Visualize the binary rules in training dataset
plot_binary_RF(Data = object,
               classifier = RF_classifier,
               prediction = NULL, 
               as_training = TRUE, # to extract the scores from the model
               show_scores = TRUE,
               top_anno = "ref",
               show_predictions = TRUE, 
               #margin = c(0,5,0,8),
               title = "Training data")

```


```{r echo=TRUE, error = TRUE}
# Visualize the binary rules in testing dataset
plot_binary_RF(Data = test,
               ref = "classes", # Get ref labels from the test ExpressionSet
               classifier = RF_classifier,
               prediction = results, 
               as_training = FALSE, 
               show_scores = TRUE,
               top_anno = "ref",
               show_predictions = TRUE,
               title = "Testing data")


```


## Heatmap with top k genes obtained with Random Forest
```{r echo=TRUE}
# Top 50 genes for all classes retrieved with random forest are in :
#genes_RF[["RF_scheme"]][["sorted_genes"]][["all"]]

# Create expression data
expression_data <- exprs(expressionset_data)

# Retrieve gene expression values and samples corresponding to those top 50 genes obtained with random forest
top50_randomforest <- expression_data[genes_RF[["RF_scheme"]][["sorted_genes"]][["all"]],]
# Samples are in columns and genes are in rows 
```



```{r echo=TRUE}
# Scale data before heatmap
top50_randomforest <- scale(top50_randomforest, center = TRUE, scale = TRUE)
```


```{r echo=TRUE, message=FALSE, warning=FALSE}

# Order columns in matrix to have the same order as the new rownames order in ann df
top50_randomforest <- top50_randomforest[ , rownames(ann)]


# Open png instance if you want to save heatmap
png(file="heatmap_randomforest.png")

# Create Matrix of the top k genes for all classes
heatmap_randomforest <- Heatmap(top50_randomforest, 
                                column_title="Top k genes with Random Forest
                                Samples",
                                name = "Genes exp", #title of legend
                                row_title = "Genes", # title of rows
                                column_names_gp = gpar(fontsize = 5), # text size
                                row_names_gp = gpar(fontsize = 5), # text size
                                show_column_dend = FALSE, # don"t show dendrogram for cols
                                cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                                column_dend_reorder = FALSE, # same as cluster_columns
                                top_annotation = colAnn, # give the colors for classes
                                show_column_names = FALSE) # don't show column names (not readable because lot of samples/columns)



# Draw heatmap
draw(heatmap_randomforest)
# Stop graph device
dev.off()
```


```{r echo=TRUE, message=FALSE, warning=FALSE}
# Draw heatmap with top k genes obtained with random forest
draw(heatmap_randomforest)
```



## Conclusion Random Forest

We used the object created with multiclasspairs to build the random forest model. Therefore, we used the same training and testing data as previously with multiclasspairs.

The first heatmaps indicate the rules for the training and the test.
The last heatmap shows the top k genes expression values according to samples.


For more information :

https://github.com/NourMarzouka/multiclassPairs

https://cran.r-project.org/web/packages/multiclassPairs/multiclassPairs.pdf

https://www.datanovia.com/en/lessons/heatmap-in-r-static-and-interactive-visualization/











# Step 3 : PAMR with all data

The surrogate variable analysis functions have been developed for population level analyses such as differential expression analysis in microarrays. In some cases, the goal of an analysis is prediction. In this case, data sets are generally composed a training set and a test set. For each sample in the training set, the outcome/class is known, but latent sources of variability are unknown. For the samples in the test set, neither the outcome/class or the latent sources of variability are known. “Frozen” surrogate variable analysis can be used to remove latent variation in the test data set. To illustrate these functions, the leukemia data can be separated into a training and test set.


```{r echo=TRUE, message=FALSE, warning=FALSE}

# Set seed for reproductibility
#set.seed(1234)


# Create train and test set with expression gene data from train and test dataset
# used with multiclasspairs
train_pamr <- exprs(train)
test_pamr <- exprs(test)

# Create train and test set with phenotype data from train and test dataset
# used with multiclasspairs
train_pamr_pheno <- pData(train)
test_pamr_pheno <- pData(test)
```


```{r echo=T, results='hide', message=F, warning=F}
# Using these data sets, the pamr package can be used to train a predictive model on the training data, as well as test 
# Prediction on a test data set.

# Data
mydata = list(x=train_pamr,y=train_pamr_pheno$classes, geneid=rownames(train_pamr),
              samplelabels=rownames(train_pamr_pheno), genenames=rownames(train_pamr))

# Train classifier
mytrain = pamr.train(mydata)
mytrain
```



```{r echo=TRUE}

# Show predictions
table(pamr.predict(mytrain,test_pamr,threshold=2),test_pamr_pheno$classes)
```


```{r echo=T, results='hide', message=F, warning=F}
## Cross-validate the classifier
# K3 cross-validation means dividing the dataset into 3 parts, while K5 cross-validation divides it into 5 parts.
# With nfold=3 we have an error rate of 0.21
# With nfold = 5 we have an error rate of 0.23
# Cross-validation with a larger number of folds (K3 or K5) is generally preferable as it provides a better estimation of the model's performance using different combinations of training and testing sets.
pamr.results<- pamr.cv(mytrain, mydata, nfold=3)
```

```{r echo=T}
pamr.results
```



```{r echo=TRUE}
# Confusion matrix with pamr.confusion function
pamr.confusion(pamr.results,threshold=1)
```


```{r echo=TRUE}

# Create dataframe with PAMR predictions
Predictions_pamr <- data.frame(pamr.predict(mytrain,test_pamr,threshold=2))

# Create rownames in dataframe thanks to rownames in test data (samples)
rownames(Predictions_pamr) <- rownames(test_pamr_pheno)

# Create Reference column in dataframe to have the classes/outcomes
Predictions_pamr["Reference"] <- test_pamr_pheno[,"classes"]

# Rename first column in dataframe 
colnames(Predictions_pamr)[1] <- "Predictions"



# Create confusion matrix on test data
confusion_matrix_pamr <- confusionMatrix(data = Predictions_pamr[,"Predictions"],
                reference = Predictions_pamr[,"Reference"],
                mode = "everything")

# Show Confusion matrix on test data using PAMR classifier
confusion_matrix_pamr

```


```{r echo=TRUE}
## Plot the cross-validated error curves
#par(mar = c(2, 2, 2, 2))
pamr.plotcv(pamr.results)
```

```{r echo=TRUE}
## Compute the confusion matrix for our model 
pamr.confusion(pamr.results, threshold=1)
```



```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED FOR TRESHOLD

## Plot the class centroids
# Note that more the treshold is high less genes you'll have on the plot and otherwise
pamr.plotcen(mytrain, mydata, threshold=6.5)
```



```{r echo=T, results='hide', message=F, warning=F}
# Estimate false discovery rates and plot them
fdr.obj<- pamr.fdr(mytrain, mydata)
```

```{r echo=TRUE}
# Show head of false discovery rate object
knitr::kable(head(fdr.obj))
```



```{r include=FALSE}
## List the significant genes
# More the treshold is high less genes we'll have
# More the treshold is low, more genes we'll have
pamr_top_genes <- pamr.listgenes(mytrain, mydata, threshold=3)

# Show the genes list
#pamr_top_genes
```


```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO THE NUMBER OF CLASSES/OUTCOMES

# Convert matrix to data frame for better manipulation
pamr_top_genes <- as.data.frame(pamr_top_genes, stringsAsFactors = FALSE)

# Reorder the data frame based on non-zero values in columns 
# The idea is to have the 0 values at the bottom and values different than 0 at the top of the df/matrix to select the first top-k genes to represent in the heatmap afterwards
non_zero_rows <- pamr_top_genes[rowSums(pamr_top_genes[, 2:8] != 0) > 0, ]
zero_rows <- pamr_top_genes[rowSums(pamr_top_genes[, 2:8] == 0) == 4, ]

# Store the previous results in one object
pamr_top_genes <- rbind(non_zero_rows, zero_rows)

# Convert data frame to matrix 
pamr_top_genes <- as.matrix(pamr_top_genes)

# Collect gene expression values corresponding to our top genes obtained with PAMR
top50_genes_pamr <- expression_data[pamr_top_genes[,"id"],]

# Select the first top 50 genes in our list
top50_genes_pamr <- top50_genes_pamr[c(1:50),]
```



```{r echo=TRUE}
# Scale data before heatmap
top50_genes_pamr <- scale(top50_genes_pamr, center = TRUE, scale = TRUE)
```


## Heatmap with top k genes obtained with PAMR
```{r echo=TRUE, message=FALSE, warning=FALSE, error = TRUE}
# Order columns in matrix to have the same order as the new rownames order in ann df
top50_genes_pamr <- top50_genes_pamr[ , rownames(ann)]


# Open png instance if you want to save heatmap
png(file="heatmap_pamr.png")

# Create Matrix of the top k genes for all classes
heatmap_pamr <- Heatmap(top50_genes_pamr, 
                        name = "Genes exp", #title of legend
                        column_title = "Top k genes with PAMR
                        Samples", # title of columns
                        row_title = "Genes", # title of rows
                        column_names_gp = gpar(fontsize = 5), # text size
                        row_names_gp = gpar(fontsize = 5), # text size
                        show_column_dend = FALSE, # don"t show dendrogram for cols
                        cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                        column_dend_reorder = FALSE, # same as cluster_columns
                        top_annotation = colAnn, # give the colors for classes
                        show_column_names = FALSE,# don't show column names (not readable because lot of samples/columns)
                        ) 


# Draw matrix
draw(heatmap_pamr)
# Stop graph device
dev.off()
```


```{r echo=TRUE}
# Draw heatmap with top k genes obtained with PAMR Classifier
draw(heatmap_pamr)
```


## Conclusion PAMR

To conclude, we can't use ExpressionSet object directly with this library. Therefore, we had to extract expression data and phenotype data from the ExpressionSet object created for multiclasspairs and random forest algorithms. Thus, we have a matrix for train and test (genes in rownames and samples in columns) with gene expressions values, and we have a dataframe for train and test with samples in rownames and one column containing the real classes/outcomes of those samples. In the end, we ploted the most significative genes with a heatmap.


For more information :
  
http://compdiag.molgen.mpg.de/ngfn/docs/2004/nov/exercises-classification.pdf

https://rdrr.io/bioc/sva/f/inst/doc/sva.pdf

https://tibshirani.su.domains/PAM/Rdist/doc/readme.html

https://cran.r-project.org/web/packages/pamr/pamr.pdf

https://www.quantargo.com/help/r/latest/packages/pamr/1.56.1/pamr.cv





# Step 4 : Random Forest SRC with all data


```{r echo=TRUE}

# Set seed for reproductibility
#set.seed(1234)

# Create train and test set with expression gene data from train and test dataset
# used with Multiclasspairs
train_rfsrc <- exprs(train)
test_rfsrc <- exprs(test)

# Create train and test set with phenotype data from train and test dataset
# used with multiclasspairs
train_rfsrc_pheno <- pData(train)
test_rfsrc_pheno <- pData(test)


# Create column classes/outcomes to have the classes/outcomes with gene expressions values
train_rfsrc2 <- cbind.data.frame(train_rfsrc_pheno$classes,t(train_rfsrc))
test_rfsrc2 <- cbind.data.frame(test_rfsrc_pheno$classes,t(test_rfsrc))
# To use rfsrc we need to have genes in columns and samples in rownames


# Rename column for further analysis
colnames(train_rfsrc2)[1] <- "Classes"
colnames(test_rfsrc2)[1] <- "Classes"

```




```{r echo=TRUE}
# Apply random forest src on our data to train the forest
# We need to have matrix with samples in rows and genes in rownames (+ outcome/label in column)
# Accuracy around 78% with this model
random_forest_src <- rfsrc(Classes ~ ., data = train_rfsrc2, nsplit = 10)
print(random_forest_src)
```





```{r echo=TRUE}
# In order to help us define the best parameters of random forest SRC model we can use the function tune and adapt our parameters in rfsrc function
tune_model <- tune(Classes ~ ., data = train_rfsrc2, sampsize = 100)



## Visualize the error rate according to mtry (Y axis) and nodesize (X axis)
plot.tune <- function(tune_model, linear = TRUE) {
  x <- tune_model$results[,1]
  y <- tune_model$results[,2]
  z <- tune_model$results[,3]
  so <- interp(x=x, y=y, z=z, linear = linear)
  idx <- which.min(z)
  x0 <- x[idx]
  y0 <- y[idx]
  filled.contour(x = so$x,
                 y = so$y,
                 z = so$z,
                 xlim = range(so$x, finite = TRUE) + c(-2, 2),
                 ylim = range(so$y, finite = TRUE) + c(-2, 2),
                 color.palette =
                   colorRampPalette(c("yellow", "red")),
                 xlab = "nodesize",
                 ylab = "mtry",
                 main = "error rate for nodesize and mtry",
                 key.title = title(main = "OOB error", cex.main = 1),
                 plot.axes = {axis(1);axis(2);points(x0,y0,pch="x",cex=1,font=2);
                   points(x,y,pch=16,cex=.25)})
  }
  

## Apply plot.tune function on our model
plot.tune(tune_model=tune_model)
```


```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED (PAREMETERS TO CHOOSE SUCH AS NSPLIT, NODESIZE, MTRY,...)

# Therefore we can try with the following parameters
# Note that we tried many different options but those ones seem interesting
# Of course it can still be modified
# But with this we loose accuracy, around 66% here compared to 78% with the previous model where we had smaller number of samples in the trees

#random_forest_src <- rfsrc(Classes ~ ., data = train_rfsrc2, nsplit = 1000, splitrule = "gini",
 #                          nodesize=15, mtry= 20)
#print(random_forest_src)

# The following model shows better accuracy than the previous one and we still have "high" number of samples in the trees so maybe it's better to use this one
random_forest_src <- rfsrc(Classes ~ ., data = train_rfsrc2, nsplit = 1000, splitrule = "gini",
                           nodesize=10, mtry= 30)
print(random_forest_src)

```

```{r echo=TRUE}
# We can plot the error rate by classes according to the number of trees to see how it progresses
plot.rfsrc(random_forest_src)
```



```{r echo=TRUE}
## After training the forest we can predict on test data with Random Forest SRC Classifier
predict_rfsrc <- predict(random_forest_src, test_rfsrc2)
print(predict_rfsrc)
```


```{r echo=TRUE, message=FALSE, warning=FALSE}
# Create confusion matrix obtained with random forest SRC classifier
confusion_matrix_rfsrc <- confusionMatrix(data = factor(predict_rfsrc[["class"]]),
                reference = factor(test_rfsrc_pheno[,"classes"]),
                
                mode="everything") 

confusion_matrix_rfsrc
```



```{r echo=TRUE}

## Find interactions function
# Find pairwise interactions between variables
# ‘method="vimp"’
# This invokes a joint-VIMP approach. Two variables are paired and their paired VIMP calculated (refered to as ’Paired’ importance). The VIMP for each separate variable is also calculated. The sum of these two values is refered to as ’Additive’ importance. A large positive or negative difference between ’Paired’ and ’Additive’ indicates an association worth pursuing if the univariate VIMP for each of the paired-variables is reasonably large. See Ishwaran (2007) for more details.
interactions_between_genes <- find.interaction(random_forest_src, method = "vimp", nvar = 8)

# Display head of table
knitr::kable(head(interactions_between_genes))
```



```{r echo=TRUE}
# Since the model contains hundreds of trees with different splits, if we want to visualize a single tree that has the generalized results of all trees, maybe its best to create a single decision tree model.

# Maybe that can help but not sure that it's possible to get only one single tree that has the generalized/most important results :
# https://gist.github.com/richpauloo/8742761e131bd6a0486a40df2b9d1f01
# https://github.com/swager/randomForestCI
# https://stackoverflow.com/questions/55985294/obtain-importance-of-individual-trees-in-a-randomforest?rq=2
# https://stackoverflow.com/questions/76678459/extracting-and-plotting-tree-from-the-rf-model

# Usually we just use get.tree and give the id of the tree that we want to plot (here in the example it's the 10th tree over 500 that we created)

# Plot trees
# We can use class.type = "rfq", ensemble = TRUE or class.type = "bayes", ensemble = TRUE as well
# Or we can also use an unsupervised analysis with 
# new_data.unspv <- rfsrc(data = train_rfsrc2)
# And then plot get.tree as well

# We can plot the four first trees
# It's not possible to get the importance of the trees
# But we can get the importance of features (genes) with vimp or var.select
# That's what we do afterwards to get the top k genes

# Plot first four trees
rfsrc_tree1 <- plot(get.tree(random_forest_src, 1))
rfsrc_tree2 <- plot(get.tree(random_forest_src, 2))
rfsrc_tree3 <- plot(get.tree(random_forest_src, 3))
rfsrc_tree4 <- plot(get.tree(random_forest_src, 4))
rfsrc_tree1
rfsrc_tree2
rfsrc_tree3
rfsrc_tree4

# If you want to save plot you can do the following
saveWidget(rfsrc_tree1, "rfsrc_tree1.html")
saveWidget(rfsrc_tree2, "rfsrc_tree2.html")
saveWidget(rfsrc_tree3, "rfsrc_tree3.html")
saveWidget(rfsrc_tree4, "rfsrc_tree4.html")

```









## Heatmap with top k genes obtained with random forest SRC
```{r echo=TRUE}
# Get top genes 
# Extract the variable importance measures with vimp 
# Or we can also use var.select(model) but vimp is more precise because we can have the importance of genes by class and for all classes while var.select gives only for all classes and not the importance by class
top50_genes_rfsrc <- vimp(random_forest_src)
# Store variable importance measures
top50_genes_rfsrc <- top50_genes_rfsrc[["importance"]]


# Sort/order matrix by decreasing order to have the top genes
top50_genes_rfsrc <- top50_genes_rfsrc[order(top50_genes_rfsrc[, 1], decreasing=TRUE), ]
# Select the first top k genes
top50_genes_rfsrc <- rownames(top50_genes_rfsrc)[1:50]
```


```{r echo=TRUE}
# Retrieve expression data in matrix corresponding to the filtered genes rfsrc 
# In matrix genes are in rownames
top50_genes_rfsrc <- expression_data[top50_genes_rfsrc,]
```


```{r echo=TRUE}
# Scale data before heatmap
top50_genes_rfsrc <- scale(top50_genes_rfsrc, center = TRUE, scale = TRUE)
```

```{r echo=TRUE, message=FALSE, warning=FALSE, error = TRUE}

# Order columns in matrix to have the same order as the new rownames order in ann df
top50_genes_rfsrc <- top50_genes_rfsrc[ , rownames(ann)]


# Open png instance if you want to save heatmap
png(file="heatmap_randomforestSRC.png")


# Create Matrix of the top k genes for all classes
heatmap_randomforestSRC <- Heatmap(top50_genes_rfsrc, 
                                name = "Genes exp", #title of legend
                                column_title = "Top k genes with Random Forest SRC
                                Samples", # title of columns
                                row_title = "Genes", # title of rows
                                column_names_gp = gpar(fontsize = 5), # text size
                                row_names_gp = gpar(fontsize = 5), # text size
                                show_column_dend = FALSE, # don"t show dendrogram for cols
                                cluster_columns = FALSE, # don't cluster otherwise classes are shuffled and it's not ordered
                                column_dend_reorder = FALSE, # same as cluster_columns
                                top_annotation = colAnn, # give the colors for classes
                                show_column_names = FALSE) # don't show column names (not readable because lot of samples/columns)


# Draw matrix
draw(heatmap_randomforestSRC)

# Stop graph device
dev.off()
```

```{r echo=TRUE}
# Draw heatmap of top k genes obtained with Random Forest SRC classifier
draw(heatmap_randomforestSRC)
```


## Conclusion RandomForestSRC

To conclude, we can't use directly an ExpressionSet object with random forest SRC neither. Indeed, we had to create a dataframe with samples in rownames and genes in columns. And we also had to have the real classes/outcomes as a column corresponding to each sample. Thus, we also used the same train and test data used with the previous libraries. In the end, we produced a heatmap with the top k genes obtained with random forest SRC.


For more information :

https://cran.r-project.org/web/packages/randomForestSRC/randomForestSRC.pdf

https://www.rdocumentation.org/packages/randomForestSRC/versions/3.1.1

https://www.randomforestsrc.org/articles/getstarted.html

https://riptutorial.com/r/example/13086/random-forest-survival-analysis-with-randomforestsrc




# Step 5 : Comparison of the four libraries (summary)


```{r echo=TRUE}

# Store top gene names for each library because for now they are matrices with samples, genes expression values etc, 
# There are not only the gene names in those objects (top50_multiclasspairs, etc)

# Multiclasspair
filtered_genes_multiclasspairs <- rownames(top50_multiclasspairs)


# pamr
filtered_genes_pamr <- rownames(top50_genes_pamr)


# random forest
filtered_genes_rf <- rownames(top50_randomforest)


# random forest SRC
filtered_genes_rfsrc <- rownames(top50_genes_rfsrc)
```


## Metrics: Accuracy and Kappa for all libraries
```{r echo=TRUE}
# Create dataframe with accuracy and kappa values for all libraries
# Add c() when using results from multiple libraries
# Store accuracy values for each library
Accuracy_multiclass <- confusion_matrix_multiclasspairs[["overall"]][["Accuracy"]]
Accuracy_rf <- confusion_matrix_rf[["overall"]][["Accuracy"]]
Accuracy_pamr <- confusion_matrix_pamr[["overall"]][["Accuracy"]]
Accuracy_rfsrc <- confusion_matrix_rfsrc[["overall"]][["Accuracy"]]
All_accuracy <- c(Accuracy_multiclass, Accuracy_rf, Accuracy_pamr, Accuracy_rfsrc)

# Store kappa values for each library
Kappa_multiclass <- confusion_matrix_multiclasspairs[["overall"]][["Kappa"]]
Kappa_rf <- confusion_matrix_rf[["overall"]][["Kappa"]]
Kappa_pamr <- confusion_matrix_pamr[["overall"]][["Kappa"]]
Kappa_rfsrc <- confusion_matrix_rfsrc[["overall"]][["Kappa"]]
All_kappa <- c(Kappa_multiclass, Kappa_rf, Kappa_pamr, Kappa_rfsrc)

# Create dataframe with accuracy and kappa values that we have stored
df_all_confusion_matrices <- data.frame(All_accuracy, All_kappa)



# Rename rownames to have the libraries' names
rownames(df_all_confusion_matrices) <- c("Multiclasspairs", "Random_Forest","PamR","Random_Forest_SRC")

# Show table
knitr::kable(df_all_confusion_matrices)
```



## Other metrics : Specificity, Sensitivity, Precision,... for all libraries
```{r echo=TRUE}

############### STEP THAT NEEDS TO BE ADAPTED ACCORDING TO CLASSES/OUTCOMES NAMES


# Create dataframe with sensitivity, specificity, etc for each class for all libraries
# Store those results for each library
Metrics_multiclass <- confusion_matrix_multiclasspairs[["byClass"]]
Metrics_rf <- confusion_matrix_rf[["byClass"]]
Metrics_pamr <- confusion_matrix_pamr[["byClass"]]
Metrics_rfsrc <- confusion_matrix_rfsrc[["byClass"]]

# Concatenate all matrices into one
All_metrics <- rbind(Metrics_multiclass, Metrics_rf, Metrics_pamr, Metrics_rfsrc)

# Rename rownames
rownames(All_metrics) <- c("Class_1_Multiclasspairs",
                           "Class_2_Multiclasspairs",
                           "Class_3_Multiclasspairs",
                           "Class_4_Multiclasspairs",
                           "Class_5_Multiclasspairs",
                           "Class_6_Multiclasspairs",
                           "Class_7_Multiclasspairs",
                           "Class_1_Random_Forest",
                           "Class_2_Random_Forest",
                           "Class_3_Random_Forest",
                           "Class_4_Random_Forest",
                           "Class_5_Random_Forest",
                           "Class_6_Random_Forest",
                           "Class_7_Random_Forest",
                           "Class_1_pamR",
                           "Class_2_pamR",
                           "Class_3_pamR",
                           "Class_4_pamR",
                           "Class_5_pamR",
                           "Class_6_pamR",
                           "Class_7_pamR",
                           "Class_1_Random_Forest_SRC",
                           "Class_2_Random_Forest_SRC", 
                           "Class_3_Random_Forest_SRC", 
                           "Class_4_Random_Forest_SRC", 
                           "Class_5_Random_Forest_SRC", 
                           "Class_6_Random_Forest_SRC", 
                           "Class_7_Random_Forest_SRC")
                           
                           
                          

# Show table with metrics
knitr::kable(All_metrics)
```


## Top genes for all libraries 
```{r echo=TRUE}

# Store top genes names for all libraries
Vector_topgenes_Multiclass <- rownames(top50_multiclasspairs)
Vector_topgenes_Rf <- rownames(top50_randomforest)
Vector_topgenes_Pamr <- rownames(top50_genes_pamr)
Vector_topgenes_Rfsrc <- rownames(top50_genes_rfsrc)

# Calculate max length of the previous vectors containing top genes names for all libraries
max_length <- max(length(Vector_topgenes_Multiclass), length(Vector_topgenes_Rf), length(Vector_topgenes_Pamr), length(Vector_topgenes_Rfsrc))

#set length of each vector equal to max length
length(Vector_topgenes_Multiclass) <- max_length
length(Vector_topgenes_Rf) <- max_length
length(Vector_topgenes_Pamr) <- max_length
length(Vector_topgenes_Rfsrc) <- max_length

# We did that because we have vectors of different lengths 
# If we do nothing the vector with less values will add the same values over and over again
# If we do that, the vector with less values will add na values instead of creating "fake" values


# Create dataframes with the previous vectors containing top gene symbols
df_top_genes_all <- data.frame(Multiclasspairs = Vector_topgenes_Multiclass,
                              Random_Forest = Vector_topgenes_Rf,
                              PamR = Vector_topgenes_Pamr,
                              Random_Forest_SRC = Vector_topgenes_Rfsrc)
```

```{r echo=TRUE}
# Order df_top_genes_all to align common genes between the libraries
df_top_genes_all2 <- df_top_genes_all
#Get matched indices between the columns
# For random forest
inds1 <- match(df_top_genes_all$Multiclasspairs, df_top_genes_all$Random_Forest)
inds2 <- match(df_top_genes_all$Random_Forest, df_top_genes_all$Multiclasspairs)
# For pamR
inds3 <- match(df_top_genes_all$Multiclasspairs, df_top_genes_all$PamR)
inds4 <- match(df_top_genes_all$PamR, df_top_genes_all$Multiclasspairs)
# For random forest SRC
inds5 <- match(df_top_genes_all$Multiclasspairs, df_top_genes_all$Random_Forest_SRC)
inds6 <- match(df_top_genes_all$Random_Forest_SRC, df_top_genes_all$Multiclasspairs)

#Replace value in B columns (random forest, pamr, random forest SRC) in the same order as A (multiclasspairs)
df_top_genes_all2$Random_Forest <- df_top_genes_all$Random_Forest[inds1]
df_top_genes_all2$PamR <- df_top_genes_all$PamR[inds3]
df_top_genes_all2$Random_Forest_SRC <- df_top_genes_all$Random_Forest_SRC[inds5]


#Order by columns B (random forest, pamr, random forest SRC)
df_top_genes_all2 <- df_top_genes_all2[order(df_top_genes_all2$Random_Forest), ]
df_top_genes_all2 <- df_top_genes_all2[order(df_top_genes_all2$PamR), ]
df_top_genes_all2 <- df_top_genes_all2[order(df_top_genes_all2$Random_Forest_SRC), ]

#Replace NA in B (random forest, pamr, random forest SRC) with unmatched value.
df_top_genes_all2$Random_Forest[is.na(df_top_genes_all2$Random_Forest)] <- df_top_genes_all$Random_Forest[is.na(inds2)]
df_top_genes_all2$PamR[is.na(df_top_genes_all2$PamR)] <- df_top_genes_all$PamR[is.na(inds4)]
df_top_genes_all2$Random_Forest_SRC[is.na(df_top_genes_all2$Random_Forest_SRC)] <- df_top_genes_all$Random_Forest_SRC[is.na(inds6)]

# Display table
knitr::kable(df_top_genes_all2)

# If you want to save file you can do the following :
write_xlsx(df_top_genes_all2,"Top_genes.xlsx")
```


## Number of common genes between libraries 
```{r echo=TRUE}
# Tab representing the number of common top genes between the four libraries

df_common_genes <- data.frame(Library = c("Multiclasspairs","Random_Forest", "PamR", "Random_Forest_SRC"),
                              Multiclasspairs=c(sum(filtered_genes_multiclasspairs %in% filtered_genes_multiclasspairs),sum(filtered_genes_multiclasspairs %in% filtered_genes_rf),sum(filtered_genes_multiclasspairs %in% filtered_genes_pamr),sum(filtered_genes_multiclasspairs %in% filtered_genes_rfsrc)),
                              Random_Forest =c(sum(filtered_genes_rf %in% filtered_genes_multiclasspairs),sum(filtered_genes_rf %in% filtered_genes_rf),sum(filtered_genes_rf %in% filtered_genes_pamr),sum(filtered_genes_rf %in% filtered_genes_rfsrc)),
                              PamR = c(sum(filtered_genes_pamr %in% filtered_genes_multiclasspairs),sum(filtered_genes_pamr %in% filtered_genes_rf),sum(filtered_genes_pamr %in% filtered_genes_pamr),sum(filtered_genes_pamr %in% filtered_genes_rfsrc)),
                              Random_Forest_SRC = c(sum(filtered_genes_rfsrc %in% filtered_genes_multiclasspairs),sum(filtered_genes_rfsrc %in% filtered_genes_rf),sum(filtered_genes_rfsrc %in% filtered_genes_pamr),sum(filtered_genes_rfsrc %in% filtered_genes_rfsrc)))

# Display table
knitr::kable(df_common_genes)
```





## Final Conclusion 

With the previous summary tabs, we can say that the library having the best accuracy is random forest SRC (72%), followed by random forest (64%), followed by pamR (63%), followed by multiclasspairs (48%). The libraries where we have the more top common genes are random forest, pamR and random forest SRC. In fact, multiclasspairs almost doesn't have common top genes with the other libraries.




```{r echo=TRUE}
sessionInfo()
```

















